"use strict";
/* IMPORT */
const fs = require("fs");
const path = require("path");
/* TINY READDIR */
const readdir = (rootPath, options) => {
    var _a, _b, _c;
    const maxDepth = (_a = options === null || options === void 0 ? void 0 : options.depth) !== null && _a !== void 0 ? _a : Infinity, isIgnored = (_b = options === null || options === void 0 ? void 0 : options.ignore) !== null && _b !== void 0 ? _b : (() => false), signal = (_c = options === null || options === void 0 ? void 0 : options.signal) !== null && _c !== void 0 ? _c : { aborted: false }, directories = [], files = [], resultEmpty = { directories: [], files: [] }, result = { directories, files };
    const handleDirents = (dirents, depth) => {
        return Promise.all(dirents.map((dirent) => {
            if (signal.aborted)
                return;
            const subPath = path.resolve(rootPath, dirent.name);
            if (isIgnored(subPath))
                return;
            if (dirent.isFile()) {
                files.push(subPath);
            }
            else if (dirent.isDirectory()) {
                directories.push(subPath);
                if (depth >= maxDepth)
                    return;
                return populateResult(subPath, depth + 1);
            }
        }));
    };
    const populateResult = async (rootPath, depth = 1) => {
        if (signal.aborted)
            return resultEmpty;
        if (depth > maxDepth)
            return result;
        const dirents = await fs.promises.readdir(rootPath, { withFileTypes: true }).catch(() => []);
        if (signal.aborted)
            return resultEmpty;
        if (!dirents.length)
            return result;
        await handleDirents(dirents, depth);
        if (signal.aborted)
            return resultEmpty;
        return result;
    };
    return populateResult(rootPath);
};
/* EXPORT */
module.exports = readdir;
module.exports.default = readdir;
Object.defineProperty(module.exports, "__esModule", { value: true });
